<template>
  <div class="page-box" style="position: relative;">
    <table-box
      ref="restaurantCart"
      class="page-table"
      :data="restaurantCartWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((restaurantCartWidgetCurrentPage - 1) * restaurantCartWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="restaurantCartWidget.onSortChange"
      @refresh="restaurantCartWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formRestaurantCartInfo:formRestaurantCatrtInfo:add')"
          @click="onAddClick()"
          >
          新建
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :disabled="!checkPermCodeExist('formRestaurantCartInfo:formRestaurantCatrtInfo:import')"
          :on-change="onImportClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
              :disabled="!checkPermCodeExist('formRestaurantCartInfo:formRestaurantCatrtInfo:import')"
            >
              导入
            </el-button>
          </template>
        </el-upload>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formRestaurantCartInfo:formRestaurantCatrtInfo:export')"
          @click="onExportClick()"
          >
          导出
        </el-button>
      </template>
      <vxe-column title="序号" type="seq" :index="restaurantCartWidget.getTableIndex" :width="80" />
      <vxe-column title="主键id" field="id" />
      <vxe-column title="用户id" field="userId" />
      <vxe-column title="餐馆id" field="restaurantId" />
      <vxe-column title="美食id" field="restaurantFoodId" />
      <vxe-column title="数量" field="count" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditClick(scope.row)"
            :disabled="!checkPermCodeExist('formRestaurantCartInfo:formRestaurantCatrtInfo:edit')"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteClick(scope.row)"
            :disabled="!checkPermCodeExist('formRestaurantCartInfo:formRestaurantCatrtInfo:delete')"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="restaurantCartWidgetTotalCount"
            :current-page="restaurantCartWidgetCurrentPage"
            :page-size="restaurantCartWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="restaurantCartWidget.onCurrentPageChange"
            @size-change="restaurantCartWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formRestaurantCartInfo',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { RestaurantCartData } from '@/api/generated/restaurantCartController';
import { RestaurantCartController } from '@/api/generated';
import FormEditRestaurantCart from '@/pages/generated/formEditRestaurantCart.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);


const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormRestaurantCatrtInfo();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadRestaurantCartWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
  };
  return new Promise((resolve, reject) => {
    RestaurantCartController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadRestaurantCartVerify = () => {
  return true;
};
/**
 * 新建
 */
const onAddClick = (row?: RestaurantCartData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditRestaurantCart, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      restaurantCartWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditClick = (row?: RestaurantCartData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditRestaurantCart, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      restaurantCartWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导入
 */
const onImportClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  RestaurantCartController.import(params).then(res => {
    ElMessage.success('导入成功');
    restaurantCartWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 导出
 */
const onExportClick = (row?: RestaurantCartData) => {
  let params: ANY_OBJECT = {
  };

  RestaurantCartController.export(params, '.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 删除
 */
const onDeleteClick = (row?: RestaurantCartData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  RestaurantCartController.delete(params).then(res => {
    ElMessage.success('删除成功');
    restaurantCartWidget.refreshTable(false, 1);
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const restaurantCartOptions: TableOptions<RestaurantCartData> = {
  loadTableData: loadRestaurantCartWidgetData,
  verifyTableParameter: loadRestaurantCartVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: 'createTime',
  ascending: false,
};
// 表格组件表格组件
const restaurantCart = ref();
const restaurantCartWidget = useTable(restaurantCartOptions);
const {
  dataList: restaurantCartWidgetDataList,
  currentPage: restaurantCartWidgetCurrentPage,
  pageSize: restaurantCartWidgetPageSize,
  totalCount: restaurantCartWidgetTotalCount,
} = restaurantCartWidget;
const refreshFormRestaurantCatrtInfo = () => {
  // 刷新段落
  restaurantCartWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormRestaurantCatrtInfo = () => {
  refreshFormRestaurantCatrtInfo();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormRestaurantCatrtInfo();
};
const formInit = () => {
  refreshFormRestaurantCatrtInfo();
};

onMounted(() => {
  formInit();
});
</script>